
;
; Virtual Server Project
; Per Context Quota/Disk Limit Support
;
; (C) 2003-2004 Herbert Pötzl <herbert@13thfloor.at>
;
; this patch is free software; you can redistribute it and/or
; modify it under the terms of the GNU General Public License
; as published by the Free Software Foundation; either version 2
; of the License, or (at your option) any later version.
;
; this patch is distributed in the hope that it will be useful,
; but WITHOUT ANY WARRANTY; without even the implied warranty of
; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
; GNU General Public License for more details.
;

diff -NurpP --minimal linux-2.4.25-rc2-vs1.26/Documentation/Configure.help linux-2.4.25-rc2-vs1.26-q0.13/Documentation/Configure.help
--- linux-2.4.25-rc2-vs1.26/Documentation/Configure.help	2004-02-12 23:21:43.000000000 +0100
+++ linux-2.4.25-rc2-vs1.26-q0.13/Documentation/Configure.help	2004-02-13 00:53:54.000000000 +0100
@@ -13649,6 +13649,19 @@ CONFIG_VIOCD
   If you are running Linux on an IBM iSeries system and you want to
   read a CD drive owned by OS/400, say Y here.
 
+# Choice
+Persistent Context ID for files
+CONFIG_INOXID_NONE
+  Persistent Context IDs for your filesystem (ext2/ext3/jfs/reiser)
+  make it possible to do permission checks and per context quota,
+  which otherwise wouldn't be possible.
+
+  Disabled is the default (no context ids are stored on disc)
+  UID32/GID16 reduces GID to 16 bits, but leaves UID at 32
+  UID24/GID24 uses 8bit from UID and GID each for context id
+  UID32/GID32 uses otherwise reserved inode fields on disk
+              (only supported on ext2/ext3 for now)
+
 Quota support
 CONFIG_QUOTA
   If you say Y here, you will be able to set per user limits for disk
diff -NurpP --minimal linux-2.4.25-rc2-vs1.26/drivers/char/sysrq.c linux-2.4.25-rc2-vs1.26-q0.13/drivers/char/sysrq.c
--- linux-2.4.25-rc2-vs1.26/drivers/char/sysrq.c	2003-08-25 13:44:41.000000000 +0200
+++ linux-2.4.25-rc2-vs1.26-q0.13/drivers/char/sysrq.c	2004-02-13 00:53:54.000000000 +0100
@@ -146,6 +146,7 @@ static void go_sync(struct super_block *
 	if (remount_flag) { /* Remount R/O */
 		int ret, flags;
 		struct list_head *p;
+		struct dqhash *dqh;
 
 		if (sb->s_flags & MS_RDONLY) {
 			printk("R/O\n");
@@ -160,7 +161,9 @@ static void go_sync(struct super_block *
 				file->f_mode &= ~2;
 		}
 		file_list_unlock();
-		DQUOT_OFF(sb);
+		
+		list_for_each_entry(dqh, &sb->s_dqhs, dqh_sblist)
+			DQUOT_OFF(dqh);
 		fsync_dev(sb->s_dev);
 		flags = MS_RDONLY;
 		if (sb->s_op && sb->s_op->remount_fs) {
diff -NurpP --minimal linux-2.4.25-rc2-vs1.26/fs/Config.in linux-2.4.25-rc2-vs1.26-q0.13/fs/Config.in
--- linux-2.4.25-rc2-vs1.26/fs/Config.in	2004-02-12 22:58:34.000000000 +0100
+++ linux-2.4.25-rc2-vs1.26-q0.13/fs/Config.in	2004-02-13 00:53:54.000000000 +0100
@@ -4,6 +4,12 @@
 mainmenu_option next_comment
 comment 'File systems'
 
+choice 'Persistent Context ID for files'	\
+        "Disabled	CONFIG_INOXID_NONE	\
+         UID32/GID16	CONFIG_INOXID_GID16	\
+         UID24/GID24	CONFIG_INOXID_GID24	\
+         UID32/GID32	CONFIG_INOXID_GID32" Disabled
+
 bool 'Quota support' CONFIG_QUOTA
 dep_tristate '  VFS v0 quota format support' CONFIG_QFMT_V2 $CONFIG_QUOTA
 
diff -NurpP --minimal linux-2.4.25-rc2-vs1.26/fs/attr.c linux-2.4.25-rc2-vs1.26-q0.13/fs/attr.c
--- linux-2.4.25-rc2-vs1.26/fs/attr.c	2002-02-25 20:38:07.000000000 +0100
+++ linux-2.4.25-rc2-vs1.26-q0.13/fs/attr.c	2004-02-13 00:53:54.000000000 +0100
@@ -133,6 +133,7 @@ int notify_change(struct dentry * dentry
 	else {
 		error = inode_change_ok(inode, attr);
 		if (!error) {
+			/* should verify disk limit here */
 			if ((ia_valid & ATTR_UID && attr->ia_uid != inode->i_uid) ||
 			    (ia_valid & ATTR_GID && attr->ia_gid != inode->i_gid))
 				error = DQUOT_TRANSFER(inode, attr) ? -EDQUOT : 0;
@@ -143,6 +144,8 @@ int notify_change(struct dentry * dentry
 	unlock_kernel();
 	if (!error) {
 		unsigned long dn_mask = setattr_mask(ia_valid);
+
+		vx_dq_cond_modify(inode, current->vx_id);
 		if (dn_mask)
 			dnotify_parent(dentry, dn_mask);
 	}
diff -NurpP --minimal linux-2.4.25-rc2-vs1.26/fs/buffer.c linux-2.4.25-rc2-vs1.26-q0.13/fs/buffer.c
--- linux-2.4.25-rc2-vs1.26/fs/buffer.c	2004-02-12 22:58:34.000000000 +0100
+++ linux-2.4.25-rc2-vs1.26-q0.13/fs/buffer.c	2004-02-13 00:53:54.000000000 +0100
@@ -374,12 +374,14 @@ int sync_buffers(kdev_t dev, int wait)
 
 int fsync_super(struct super_block *sb)
 {
+	struct dqhash *dqh;
 	kdev_t dev = sb->s_dev;
 	sync_buffers(dev, 0);
 
 	lock_kernel();
 	sync_inodes_sb(sb);
-	DQUOT_SYNC_SB(sb);
+	list_for_each_entry(dqh, &sb->s_dqhs, dqh_sblist)
+		DQUOT_SYNC_DQH(dqh);
 	lock_super(sb);
 	if (sb->s_dirt && sb->s_op && sb->s_op->write_super)
 		sb->s_op->write_super(sb);
